<!DOCTYPE html>
<html layout:decorate="~{fragments/layout}">

<head>
	<title></title>
</head>

<body>
	<div layout:fragment="content">

		<h1>Role</h1>
		<div class="row">
			<div class="col-12">
				<div class="card">
					<div class="card-body">
						<div class="card-title">
							<button onclick="openModal()" class="btn btn-primary btn-rounded btn-sm">Create</button>
							<input type="text"
								class="d-inline-block form-control custom-shadow custom-radius border-0 bg-white col-7"
								id="searchRoleByName" oninput="searchRoleByName(this.value)"
								placeholder="Search Here..">

							<select id="sortRoleByName"
								class="d-inline-block custom-select form-control bg-white custom-radius custom-shadow border-0 col-1"
								onchange="sortRoleByName(this.value)">
								<option value="ASC">A-Z</option>
								<option value="DESC">Z-A</option>
							</select>
							<select id="dataSize"
								class="d-inline-block custom-select form-control bg-white custom-radius custom-shadow border-0 col-1"
								onchange="getAllRole(0, this.value)">
								<option value="5">5</option>
								<option value="10">10</option>
								<option value="15">15</option>
							</select>
							<button id="btnHapusMultiple" class="btn btn-danger btn-rounded btn-sm" disabled>Hapus
								Multiple</button>
						</div>
						<div id="isiData"></div>
					</div>
				</div>
			</div>
		</div>

		<script>
			
			$(function () {
				getAllRole(0,5)
			})
			
			function getAllRole(currentPage, size) {
				var keyword = $("#searchRoleByName").val()
				var sortType = $("#sortRoleByName").val()

				$.ajax({
					url: '/api/role/paging?currentPage=' + currentPage + '&size=' + size + '&keyword=' + keyword + '&sortType=' + sortType,
					type: 'get',
					contentType: 'application/json',
					success: function (response) {
						listView(response, size, keyword, sortType)
					}
				})
			}
			function listView(response, size, keyword, sortType) {
				var str = '<table class="table table-hover table-striped" border="1">'
				str += '<thead class="thead-dark">'
				str += '<tr>'
				str += '<th class="text-center">No</th>'
				str += '<th class="text-center">Role Name</th>'
				str += '<th class="text-center">Created Date</th>'
				str += '<th class="text-center" colspan="2">Action</th>'
				str += '</tr>'
				str += '</thead>'
				str += '<tbody>'
				for (var i = 0; i < response.data.length; i++) {
					str += '<tr>'
					str += '<td>' + (i + 1) + '</td>'
					str += '<td>' + response.data[i].roleName + '</td>'
					str += '<td>' + response.data[i].createdDate + '</td>'
					str += '<td><button class="btn btn-warning" value="' + response.data[i].id + '"onClick="f_edit(value)"><i class="fas fa-edit"></i></button></td>'
					str += '<td><button class="btn btn-danger" value="' + response.data[i].id + '"onClick="f_delete(value)"><i class= "fas fa-trash"></i></button></td>'
					str += '</tr>'
				}
				str += '</tbody>'
				str += '</table>'

				//INI PAGINGNYA
				str += '<nav aria-label="Page navigation example">'
				str += '<ul class="pagination justify-content-end">'
				var prevMove = response.pages - 1 <= 0 ? 0 : response.pages - 1
				str += '<li class="page-item">'
				str += '<a class="page-link" onClick="getAllRole(' + prevMove + ',' + size + ')">Previous</a>'
				str += '</li>'
				var index = 1
				for (var i = 0; i < response.total_pages; i++) {
					str += '<li class="page-item"><a class="page-link" onClick="getAllRole(' + i + ', ' + size + ')">' + index + '</a></li>'
					index++
				}
				var nextMove = response.pages + 1 > response.total_pages - 1 ? response.total_pages - 1 : response.pages + 1
				str += '<li class="page-item">'
				str += '<a class="page-link" onClick="getAllRole(' + nextMove + ',' + size + ')">Next</a></li>'
				str += '</li>'
				str += '</ul>'
				str += '</nav>'

				$('#isiData').empty()
				$('#isiData').html(str)
			}


			function openModal() {
				var str = '<form>'
				str += '<div class="form-group">'
				str += '<label for="roleName">Role Name</label>'
				str += '<input type="text" class="form-control" id="roleName">'
				str += '</div>'
				str += '</form>'

				$(".modal-title").html("form Role")
				$(".modal-body").html(str)
				$("#btnSave").html("Save")
				$("#btnSave").off('click').on("click", saveRole)
				$("#modal").modal('show')
			}
			function saveRole() {
				var formdata = '{'
				formdata += '"roleName":"' + $("#roleName").val() + '"'
				formdata += '}'

				$.ajax({
					url: '/api/role/add',
					data: formdata,
					type: 'post',
					contentType: 'application/json',
					success: function () {
						$("#modal").modal('toggle')
						Swal.fire(
							'Good job!',
							'You clicked the button!',
							'success'
						).then(function () {
							getAllRole(0, 5)
						})
					}
				})
			}

			function f_edit(id) {
				$.ajax({
					url: '/api/role/' + id,
					type: 'get',
					contentType: 'application/json',
					success: function (role) {
						var str = '<form>'
						str += '<div class="form-group">'
						str += '<label for="roleName">Role Name</label>'
						str += '<input type="text" class="form-control" id="roleName" value=" ' + role.roleName + '">'
						str += '</div>'
						str += '</form>'

						$(".modal-title").html("Edit Role")
						$(".modal-body").html(str)
						$("#btnSave").html("Update")
						//$("#btnSave").off('click').on("click", updateCategory)
						$("#btnSave").off('click').on('click',
							function () {
								updateRole(id)
							})
						$("#modal").modal('show')
					}
				})
			}
			function updateRole(id) {
				var formdata = '{'
				formdata += '"roleName":"' + $("#roleName").val() + '"'
				formdata += '}'

				$.ajax({
					url: '/api/role/edit/' + id,
					data: formdata,
					type: 'put',
					contentType: 'application/json',
					success: function () {
						$("#modal").modal('toggle')
						Swal.fire(
							'Good job!',
							'You clicked the button!',
							'success'
						).then(function () {
							getAllRole(0, 5)
						})
					}
				})
			}

			function f_delete(id) {
				$.ajax({
					url: '/api/role/' + id,
					type: 'get',
					contentType: 'application/json',
					success: function (data) {
						Swal.fire({
							title: 'Are you sure?',
							text: "You won't be able to revert this!",
							icon: 'warning',
							showCancelButton: true,
							confirmButtonColor: '#3085d6',
							cancelButtonColor: '#d33',
							confirmButtonText: 'Yes, delete it!'
						}).then((result) => {
							if (result.isConfirmed) {
								Swal.fire(
									'Deleted!',
									'Your file has been deleted.',
									'success'
								).then((result) => {
									deleteRole(id)
								})
							}
						})

					}
				})
			}
			function deleteRole(id) {
				$.ajax({
					url: '/api/role/delete/' + id,
					type: 'put',
					contentType: 'application/json',
					success: function () {
						getAllRole(0, 5)
					}
				})
			}

			function searchRoleByName(keyword) {
				var currentPage = 0;
				var size = 5;
				var sortType = $("#sortRoleByName").val()
				$.ajax({
					url: '/api/role/paging?currentPage=' + currentPage + '&size=' + size + '&keyword='
						+ keyword + '&sortType=' + sortType,
					type: 'get',
					contentType: 'application/json',
					success: function (response) {
						listView(response, size, keyword, sortType)
					}
				})

			}
			
			function sortRoleByName(sortType) {
                var currentPage = 0
                var size = $("#dataSize").val()
                var keyword = $("#searchRoleByName").val()
                $.ajax({
                    url: '/api/role/paging?currentPage=' + currentPage + '&size=' + size + '&keyword=' + keyword + '&sortType=' + sortType,
                    type: 'get',
                    contentType: 'application/json',
                    success: function (response) {
                        listView(response, size, keyword, sortType)
                    }
                })
            }
			
		</script>

	</div>
	</div>
</body>

</html>